import { PartialWithUndefinedReactivePropsToNativeProps, ReactivePropsToNativePropsAndChanged } from "vtxf-xe2/dist-node/xe2-base-utils";
import { SceneObjectKey } from "vtxf-xe2/dist-node/xe2-utils";
import { ESSceneObject } from "../ESSceneObject";
export declare class ScriptLoader extends ESSceneObject {
    static readonly type: string;
    get typeName(): string;
    get defaultProps(): {
        execOnceFuncStr: string | undefined;
        updateFuncStr: string | undefined;
        toDestroyFuncStr: string | undefined;
        name: string;
        ref: string | undefined;
        devTags: import("vtxf-xe2/dist-node/xe2-base-utils").ReactiveVariable<string[] | undefined>;
        extras: import("vtxf-xe2/dist-node/xe2-base-utils").ReactiveVariable<import("vtxf-xe2/dist-node/xe2-base-utils").JsonValue>;
        enabled: boolean | undefined;
        uri: string | undefined;
    };
    get json(): JsonType;
    set json(value: JsonType);
    private _loaded;
    constructor(id?: SceneObjectKey);
    load(): Promise<void>;
    reload(): Promise<void>;
    getProperties(language?: string): import("../ESSceneObject").Property[];
}
export declare namespace ScriptLoader {
    const createDefaultProps: () => {
        execOnceFuncStr: string | undefined;
        updateFuncStr: string | undefined;
        toDestroyFuncStr: string | undefined;
        name: string;
        ref: string | undefined;
        devTags: import("vtxf-xe2/dist-node/xe2-base-utils").ReactiveVariable<string[] | undefined>;
        extras: import("vtxf-xe2/dist-node/xe2-base-utils").ReactiveVariable<import("vtxf-xe2/dist-node/xe2-base-utils").JsonValue>;
        enabled: boolean | undefined;
        uri: string | undefined;
    };
}
export interface ScriptLoader extends ReactivePropsToNativePropsAndChanged<ReturnType<typeof ScriptLoader.createDefaultProps>> {
}
declare type JsonType = PartialWithUndefinedReactivePropsToNativeProps<ReturnType<typeof ScriptLoader.createDefaultProps> & {
    type: string;
}>;
export {};
